10 REM ** SIMLAB-F: THRUST CURVE SIMULATION PROGRAM **
20 REM ** USES TWO PRESSURE & RB REGIMES **
30 REM ** FOR FLAT AND BOWL-SHAPED NOZZLES ONLY **
50 REM ** ALLOWS TOTAL DEGRADATION OF BORE **
70 REM ** CALCULATES VE, RB FROM PROPELLANT PARAMETERS **
80 REM ** THIS VERSION USES A SPLINE ROUTINE **
85 REM ** THIS VERSION ALSO USES A BENT PRESSURE CURVE/KRATIO CUTOFF **
90 REM ** LARRY CURCIO, JUNE 1988 **
110 REM ==============================================================
130 DEFDBL Z: REM ** REMOVE IF NOT SUPPORTED BY YOUR SYSTEM **
150 KEY OFF: REM FOR IBM PC AND CLONES. REMOVE FOR OTHER SYSTEMS
170 NITER1 = 500: REM ** NUMBER OF ITERATIONS: ADJUST TO TASTE **
180 SPLMAX = 50: REM ** MAX NUMBER OF SPLINE POLYNOMIALS **
190 DIM F(NITER1), VE(NITER1), P(NITER1), RB(NITER1)
195 REM ** SPLINE TABLES: FROM EXTERNAL PROGRAM, MAKESPLN **
200 DIM YS(SPLMAX), XS(SPLMAX), PS(SPLMAX), US(SPLMAX)
210 PI = 3.14159265358979#: TWOPI = PI + PI: HALFPI = PI / 2!
220 MPROP1 = 999: REM SET DEFAULT PROP MASS
230 GOSUB 5470: REM ** READ PROPPARM.TST FOR PARMS **
250 SCRNWDTH = 80: REM ** CHARACTER WIDTH OF SCREEN **
270 FLAT = 90: FLATCAP = 1: ROUND = 2
290 REALBIG = 10000: REM ** LARGE NUMBER TO AVOID LEXICALLY-UPWARD GOTO'S **
310 ATMOS = 14.7 * 4.45 / (2.54 * 2.54): REM ** ATMOSPHERIC PRESSURE IN N/CM^2 **
315 ATMOS = 0: REM WHEN USING ABSOLUTE PRESSURE KEEP THIS LINE ACTIVE
330 T$ = " ": REM INITIALIZE TITLE
350 DEF FNSQ (A) = A * A: REM ****** INTERSECTION OF LINE WITH CIRCLE BELOW ******
370 DEF FNQUAD1 (A, B, C) = (-B + SQR(B * B - 4 * A * C)) / (A + A)
390 DEF FNTEST1 (A, B, C) = B * B - 4 * A * C: REM ** TESTS FOR REAL ROOTS @ PRECISION **
410 DEF FNTEST0 (A, B, R, M, C) = FNTEST1((M * M + 1), 2 * ((C - B) * M - A), FNSQ(C - B) - R * R + A * A)
430 DEF FNINTSCT (A, B, R, M, C) = FNQUAD1((M * M + 1), 2 * ((C - B) * M - A), FNSQ(C - B) - R * R + A * A)
450 DEF FNK (A, B, R1, R2) = -A * A + R1 * R1 - R2 * R2 - B * B
470 REM ****** INTERSECTION OF TWO CIRCLES, CENTER OF ONE IS ORIGIN ******
490 DEF FNINT2 (A, B, K, R) = FNQUAD1(4 * (A * A + B * B), 4 * A * K, (K * K - 4 * B * B * R * R))
510 DEF FNTEST (A, B, K, R) = FNTEST1(4 * (A * A + B * B), 4 * A * K, (K * K - 4 * B * B * R * R))
530 DEF FNTS (R, RHO, A1, A2) = TWOPI * R * (R * (SIN(A2) - SIN(A1)) + RHO * (A2 - A1))
550 DEF FNTV (R, RHO, A1, A2) = TWOPI * R * (R * R * (SIN(A2) - SIN(A1)) / 3 + R * RHO * (A2 - A1) / 2)
570 DEF FNVNOZZL (R, RHO, A1, A2, HNOZZLE) = FNTV(R, RHO, A1, A2) + PI * RHO * RHO * HNOZZLE
590 REM ********* EXECUTIVE LOOP *********
610 FOR BIGLOOP = 1 TO REALBIG
630    CLS : REM ** CLEAR SCREEN **
650    ADJRATE = 1: ADJVE = 1: FRSTRUN = 1
670    GOSUB 1150
690    TTOTHLD = TTOT: ZIMPHLD = ZDIGIMP: TTOT1 = 0
710    FOR SMALLOOP = 1 TO REALBIG
730       PRINT
750       FRSTRUN = 1: AGAIN = 0: CLS
770       PRINT "ADJUST BURNING TIME "; : INPUT A$
790       IF A$ = "n" OR A$ = "N" THEN 850
810       IF A$ <> "y" AND A$ <> "Y" THEN 770
830       AGAIN = 1: GOSUB 6330
850       PRINT
870       PRINT "ADJUST IMPULSE "; : INPUT A$
890       IF A$ = "n" OR A$ = "N" THEN 950
910       IF A$ <> "y" AND A$ <> "Y" THEN 870
930       AGAIN = 1: GOSUB 6510
950       IF AGAIN = 0 THEN 1010
970       GOSUB 1650
990    NEXT SMALLOOP
1010    PRINT
1030    FOR II = 1 TO REALBIG
1050       PRINT "ANOTHER CURVE"; : INPUT A$
1070       IF A$ = "n" OR A$ = "N" THEN 6650
1090       IF A$ = "y" OR A$ = "Y" THEN 1130
1110    NEXT II
1130 NEXT BIGLOOP: REM ********* END EXECUTIVE LOOP *********
1150 PRINT "TITLE  "; : INPUT WORK$: IF WORK$ > "" THEN T$ = WORK$
1190 CENTER = (SCRNWDTH - LEN(T$)) / 2: CLS : PRINT TAB(CENTER); T$
1210 PRINT "COMBUSTION CHAMBER RADIUS IN CM             ("; BIGR; ") ";
1230 INPUT WORK: IF WORK > 0 THEN BIGR = WORK
1250 PRINT "RADIUS OF FLAT BOTTOM (0=NONE)              ("; RFLAT; ") ";
1270 INPUT WORK$: IF WORK$ > "" THEN RFLAT = VAL(WORK$)
1290 PRINT "TYPE OF CAP:  1=FLAT, 2=ROUNDED             ("; ICAP; ") ";
1310 INPUT WORK: IF WORK > 0 THEN ICAP = WORK
1330 IF ICAP <> FLATCAP AND ICAP <> ROUND THEN 1290
1350 PRINT "NOZZLE THROAT RADIUS IN CM                  ("; R0BOTTOM; ") ";
1370 INPUT WORK$: IF WORK$ > "" THEN R0BOTTOM = VAL(WORK$)
1390 PRINT "RADIUS AT TOP OF BORE IN CM                 ("; R0TOP; ") ";
1410 INPUT WORK$: IF WORK$ > "" THEN R0TOP = VAL(WORK$)
1430 PRINT "BORE LENGTH IN CM                           ("; H; ") ";
1450 INPUT WORK$: IF WORK$ > "" THEN H = VAL(WORK$)
1470 PRINT "LENGTH OF CHARGE IN CM                      ("; LENCHRGE; ") ";
1490 INPUT WORK: IF WORK > 0 THEN LENCHRGE = WORK
1510 PRINT "PROPELLANT MASS IN GRAMS                    ("; MPROP1; ") ";
1530 INPUT WORK: IF WORK > 0 THEN MPROP1 = WORK
1630 REM ** INITIAL CALCULATIONS **
1650 THETA = 0: IF H <> 0 THEN THETA = ATN((R0BOTTOM - R0TOP) / H)
1670 COSTHETA = COS(THETA): SINTHETA = SIN(THETA): TANTHETA = SINTHETA / COSTHETA
1690 M = 0: IF TANTHETA <> 0 THEN M = -1 / TANTHETA
1710 BIGR1 = BIGR - R0TOP: BIGR2 = BIGR - R0BOTTOM: TOPA = PI * R0TOP * R0TOP
1730 T = 0: RBT = 0: RBT2 = 0: RBT0 = 0: RHOTOP = R0TOP: IF ICAP = FLATCAP THEN 1790
1750 RBT0 = R0TOP / COSTHETA: TOPA = 0: RHOTOP = 0: BIGR1 = BIGR: RBT2 = RBT0 * RBT0
1770 REM====================================================================
1790 L = R0BOTTOM - R0TOP: L = SQR(H * H + L * L): AT = R0BOTTOM * R0BOTTOM * PI
1810 IF FRSTRUN = 1 THEN DELTAT = .5 * (LENCHRGE - BORELEN) / (MINRB1 * NITER1)
1830 REM ** DEVELOPING LENGTH OF FORWARD PROPELLANT CAP **
1850 SPHEREHT = 0: REM ** DEVELOPING HEIGHT OF SPERICAL SEGMENT **
1870 IF ICAP = ROUND AND RBT0 <> 0 THEN SPHEREHT = RBT0 - SQR(RBT0 * RBT0 - R0TOP * R0TOP)
1890 LENCAP = LENCHRGE + RBT0 - SPHEREHT - H
1910 VCHAMBER = PI * BIGR * BIGR * LENCHRGE: REM ** VOLUME OF CHAMBER **
1930 REM ** ADJUST VOLUME FOR NOZZLE **
1950 RROUND = BIGR - RFLAT: REM ** ROUND PART RADIUS & HEIGHT OF NOZZLE **
1970 NOZANGLE = HALFPI: IF RROUND = 0 THEN 2010
1990 NOZANGLE = ATN((BIGR - R0BOTTOM) / RROUND)
2010 NOZANG1 = HALFPI - NOZANGLE: NOZANG10 = NOZANG1: REM ** HOLD ORIGINAL ANGLE **
2030 LNOZZLE = BIGR2: IF RROUND > 0 THEN LNOZZLE = SQR(RROUND * RROUND + BIGR2 * BIGR2)
2050 IF NOZANG1 > THETA THEN 2090
2070 BIGR3 = BIGR2 / SIN(NOZANGLE): GOTO 2150: REM** IF NOZZLE DOESN'T SHORTEN WALL **
2090 IF L / COS(NOZANGLE + THETA) < LNOZZLE THEN 2130
2110 BIGR3 = LNOZZLE * SIN(NOZANGLE + THETA): GOTO 2150: REM ** NOZZLE SHORTENS  WALL **
2130 BIGR3 = SQR(FNSQ(RROUND - H) + FNSQ(BIGR - RHOTOP)) - RBT0
2150 VNOZZLE = FNVNOZZL(RROUND, RFLAT, 0, HALFPI, RROUND)
2170 VCHAMBER = VCHAMBER - PI * BIGR * BIGR * RROUND + VNOZZLE: REM ** CORRECTED VOLUME **
2190 REM ** DEVELOP BORE VOLUME **
2210 VBORE = 0
2230 VBORE = PI * SPHEREHT * SPHEREHT * (3! * RBT0 - SPHEREHT) / 3!: REM FROM CRC MATH TABLES
2250 VBORE = VBORE + PI * H * (R0BOTTOM * R0BOTTOM + R0TOP * R0TOP + R0TOP * R0BOTTOM) / 3!
2270 VPROP = VCHAMBER - VBORE: MPROP = MPROP1: MSW = 1: IF MPROP1 = 999 THEN MSW = 0
2290 RHOPROP = RHOPROP1: IF MSW <> 0 THEN RHOPROP = MPROP1 / VPROP
2310 REM IF FRSTRUN=1 THEN ADJRATE=RHOPROP1/RHOPROP
2330 IF FRSTRUN = 1 THEN DELTAT = DELTAT / ADJRATE
2350 IF MSW = 0 THEN MPROP = RHOPROP * VPROP: REM ** PROPELLANT DENSITY **
2370 BIGK = RHOPROP: REM ** CONVERSION CONSTANT BETWEEN AREA AND THRUST **
2390 ZDIGIMP = 0: REM ** INITIALIZE DIGITAL IMPULSE (DOUBLE PRECISION) **
2410 ZDIGV = 0
2430 PRINT : PRINT "PROPELLANT DENSITY IN GM/CM^3= "; RHOPROP
2450 PRINT "PROPELLANT VOLUME IN CM^3=     "; VPROP
2470 REM PRINT "BURNING RATE IN CM/SEC=        ";RB
2490 REM PRINT "LENGTH OF FORWARD CAP IN CM=   ";LENCAP-RBT0
2510 DMAXP = 0: DTMAXP = 0: DMAXF = 0: DTMAXF = 0: MARK = 0: TEST = -1: TEST1 = -1
2530 LASTRB = MINRB: FSUST = 0: PSUST = 0: LASTP = ATMOS: LASTF = 0: NITER = NITER1
2550 REM================= ** MAIN LOOP ** ===================================
2570 FOR I = 0 TO REALBIG
2590 RTOP = R0TOP + RBT * COSTHETA: RBOTTOM = R0BOTTOM + RBT * COSTHETA
2610 REM ** BEFORE WALLS HIT AT BOTTOM **
2630 IF MARK > 1.5 THEN 3290
2650   NOZANGLE = HALFPI: NOZANG1 = 0: IF RBT + R0BOTTOM <= RFLAT THEN 3290
2670   REM ** INTERSECTION OF FRUSTUM CROSS-SECTION WITH BOWL ****
2690   IF BIGR3 < RBT THEN 3290
2710   IF L < 0 THEN 3150
2730   X = RBOTTOM
2750   IF TANTHETA = 0 THEN 2830
2770   TEST1 = FNTEST0(RFLAT, RROUND, RROUND, M, H + RBT / SINTHETA - M * R0TOP)
2790   IF TEST1 < 0 THEN 2990
2810   X = FNINTSCT(RFLAT, RROUND, RROUND, M, H + RBT / SINTHETA - M * R0TOP)
2830   IF X > BIGR THEN X = BIGR: REM ** ELIMINATES EXPLOSIONS FOR PRECISION **
2850   Y = RROUND - SQR(RROUND * RROUND - FNSQ(X - RFLAT)): X = X - R0BOTTOM
2870   L1 = H - Y: IF SINTHETA > 0 THEN L1 = (X - RTOP + R0BOTTOM) / SINTHETA
2890   IF L1 > L THEN 2990
2910   L = L1: IF L < 0 THEN 3150
2930   IF SINTHETA = 0 THEN 3090
2950      Y = X * M + H + RBT / SINTHETA - M * R0TOP
2970      GOTO 3090
2990   IF TEST >= 0 THEN 3050
3010   TEST = FNTEST(RFLAT - R0BOTTOM, RROUND, FNK(RFLAT - R0BOTTOM, RROUND, RROUND, RBT), RBT)
3030   X = RBT + RBT0: IF TEST < 0 THEN 3070
3050   X = FNINT2(RFLAT - R0BOTTOM, RROUND, FNK(RFLAT - R0BOTTOM, RROUND, RROUND, RBT), RBT)
3070   IF X <= RBT THEN Y = SQR(RBT * RBT - X * X)
3090   NOZANGLE = HALFPI: IF Y <> 0 THEN NOZANGLE = ATN(X / Y)
3110   NOZANG1 = HALFPI - NOZANGLE
3130   GOTO 3290
3150   IF TEST >= 0 THEN 3210
3170   TEST = FNTEST(RFLAT - RHOTOP, RROUND - H, FNK(RFLAT - RHOTOP, RROUND - H, RROUND, RBT + RBT0), RBT + RBT0)
3190   X = RBT + RBT0: IF TEST < 0 THEN 3230
3210   X = FNINT2(RFLAT - RHOTOP, RROUND - H, FNK(RFLAT - RHOTOP, RROUND - H, RROUND, RBT + RBT0), RBT + RBT0)
3230   Y = SQR(FNSQ(RBT + RBT0) - X * X)
3250   L = 0: MARK = 1.5: PSI = 0: IF X <> 0 THEN PSI = ATN(Y / X)
3270   A = FNTS(RBT + RBT0, RHOTOP, PSI, HALFPI) + TOPA: GOTO 3790
3290 IF BIGR < RTOP + L * SINTHETA THEN 3550
3310   A = FNTS(RBT + RBT0, RHOTOP, THETA, HALFPI) + PI * (RTOP + RTOP + L * SINTHETA) * L + TOPA
3330   REM ** BEFORE WALLS HIT BY TRAILING SPHERE: ASCENDING PORTION **
3350   IF BIGR3 < RBT THEN 3450
3370     IF THETA > NOZANG1 THEN A = A + FNTS(RBT, R0BOTTOM, NOZANG1, THETA)
3390     IF MARK < 1 THEN MARK = 1
3410     GOTO 3790
3430   REM ** TRAILING SPHERE HITS BUT FRUSTUM BASE IS CLEAR: COWLICK **
3450      IF THETA <= NOZANG10 THEN 3790
3470      THETA1 = ATN(SQR(RBT * RBT - BIGR2 * BIGR2) / BIGR2)
3490      A = A + FNTS(RBT, R0BOTTOM, THETA1, THETA): MARK = 2
3510   GOTO 3790
3530 REM ** FRUSTUM BASE HAS HIT BUT TOP HAS NOT: DESCENDING PORTION **
3550 IF BIGR < RTOP THEN 3630
3570   L = (BIGR - RTOP) / SINTHETA
3590   A = FNTS(RBT + RBT0, RHOTOP, THETA, HALFPI) + PI * (RTOP + BIGR) * L + TOPA: MARK = 3
3610   GOTO 3790
3630 REM ** FRUSTUM TOP HAS HIT: SLOW DESCENT AND SUSTAINING PORTION **
3650 THETA1 = ATN(SQR(RBT2 - BIGR1 * BIGR1) / BIGR1)
3670 A = FNTS(RBT + RBT0, RHOTOP, THETA1, HALFPI) + TOPA: MARK = 4
3690 REM ** BURNTHROUGH CONDITIONS **
3710 IF RBT + RBT0 <= LENCAP THEN 3790
3730 THETA2 = RBT2 - LENCAP * LENCAP:
3750 THETA2 = ATN(LENCAP / SQR(THETA2)): THETA1 = ATN(SQR(RBT2 - BIGR1 * BIGR1) / BIGR1)
3770 A = FNTS(RBT + RBT0, RHOTOP, THETA1, THETA2): MARK = 5
3790 F = 0: IF A < 0 THEN A = 0
3810 KN = A / AT
3815 PK = PK2: PN = PN2: AA = A2: N = N2: IF KN > CUTOFF THEN 3825
3822 PK = PK1: PN = PN1: AA = A1: N = N1
3825 P1 = PK * (KN ^ PN) + ATMOS: P = P1
3830 IF P < LOWPFORVE THEN P = LOWPFORVE
3850 IF P > HIPFORVE THEN P = HIPFORVE: REM ** DON'T EXTRAPOLATE A POLY FIT! **
3870 REM ==================================================================
3871 REM ** IN-LINE SPLINE AT VSPLN => DELIVER EVAL **
3872 REM ** ROUTINE FROM PIZER PP 311-312. USE WITH PROG, MAKESPLN. **
3873 VSPLN = P: EVAL = 0: IF P = 0 THEN 3899
3875 FOR IS1=1 TO NS-1
3877   IF VSPLN<=XS(IS1+1) THEN 3883
3879 NEXT IS1
3881 IS1=NS
3883 TSPLN=(VSPLN-XS(IS1))/US(IS1)
3885 TCOMP = 1 - TSPLN
3887 TEMP=US(IS1)*US(IS1)/6
3889 CC=PS(IS1)*TEMP:BB=PS(IS1+1)*TEMP
3891 EVAL=(CC*TCOMP*TCOMP+YS(IS1)-CC)*TCOMP+(BB*TSPLN*TSPLN+YS(IS1+1)-BB)*TSPLN
3898 REM ==================================================================
3899 VE = VECON * ADJVE * EVAL / 1000: P = P1: REM PUT P BACK
3970 RB = AA * (P ^ N): RB = RB * ADJRATE
3990 F1 = VE * RB * RHOPROP * A: F = F1
4010 REM PRINT F,VE,RB,P
4030 IF I > NITER1 THEN 4070
4050 F(I) = F: VE(I) = VE: P(I) = P: RB(I) = RB
4070 IF DMAXF >= F THEN 4110
4090 DMAXF = F: DTMAXF = T
4110 IF DMAXP >= P1 THEN 4150
4130 DMAXP = P1: DTMAXP = T
4150 T = T + DELTAT: RBT = RBT + RB * DELTAT
4170 RBT2 = (RBT + RBT0): RBT2 = RBT2 * RBT2: ZDIGIMP = ZDIGIMP + F: ZDIGV = ZDIGV + RB * DELTAT * A
4190 IF MARK <> 4 THEN 4230
4210 FSUST = F: PSUST = P1
4230 LASTP = P1: LASTF = F1: IF A = 0 THEN 4290
4250 NEXT I
4270 GOTO 4350
4290 IF I + 1 > NITER1 THEN 4330
4310 F(I + 1) = 0: VE(I) = 0: P(I) = 0: RB(I) = 0
4330 NITER = I + 1
4350 TTOT = DELTAT * NITER: NITER2 = NITER: IF NITER2 > NITER1 THEN NITER2 = NITER1
4370 REM =====================================================================
4390 REM ** PLOT ROUTINE: PC-DEPENDENT **
4410 REM ** OMIT OR REWRITE FOR OTHER SYSTEMS **
4430 YSIZE = 200: XSIZE = 640: MAXY = YSIZE - 1: MAXX = XSIZE - 1
4450 YSCALE = DMAXF: XSCALE = TTOT
4470 ZDIGIMP = DELTAT * ZDIGIMP
4490 DIGIMP = ZDIGIMP: REM ** CONVERT TO SINGLE, AVOID 'PRINTUSING' **
4510 DIGV = ZDIGV
4530 PRINT : PRINT "MAX THRUST IN N, TIME =        "; DMAXF; "  "; DTMAXF
4550 PRINT "SUSTAINING THRUST, PRESSURE =  "; FSUST; "  "; PSUST
4570 IF MSW = 0 THEN PRINT "PROPELLANT MASS IN GRAMS =     "; MPROP
4590 PRINT "BURNING TIME IN SEC =          "; TTOT
4610 PRINT "DIGITAL IMPULSE IN N-SEC =     "; DIGIMP, DIGV
4630 PRINT "AVERAGE Ve IN  M/SEC =         "; DIGIMP * 1000 / MPROP
4650 PRINT "# INTERVALS, LENGTH IN SEC =   "; NITER; "  "; TTOT / NITER
4670 PRINT "MAX PRESSURE IN N/CM^2, TIME = "; DMAXP; "  "; DTMAXP
4690 PRINT : PRINT "PRESS <RETURN> TO CONTINUE "; : INPUT "", A$
4710 FOR II = 1 TO REALBIG
4730    CLS
4750    PRINT "MAX X="; TTOT; " MAX Y="; DMAXF: PRINT : PRINT
4770    PRINT "XSCALE="; XSCALE; " YSCALE="; YSCALE: PRINT : PRINT
4790    PRINT "ENTER NEW XSCALE OR PRESS RETURN TO ACCEPT": INPUT GGG: PRINT
4810    IF GGG <> 0 THEN XSCALE = GGG
4830    PRINT "ENTER NEW YSCALE OR PRESS RETURN TO ACCEPT": INPUT GGG
4850    IF GGG <> 0 THEN YSCALE = GGG
4870    GOSUB 5150
4890    FOR JJ = 1 TO REALBIG
4910       PRINT "REPLOT "; : INPUT A$
4930       IF A$ = "y" OR A$ = "Y" THEN 4990
4950       IF A$ = "n" OR A$ = "N" THEN 5010
4970    NEXT JJ
4990 NEXT II
5010 CLS : PRINT "NAME OF OUTPUT FILE (<CR>/N FOR NONE)   "; : INPUT F$
5030 IF F$ = "N" OR F$ = "n" THEN F$ = ""
5050 IF F$ = "" THEN 5130
5070 INPUT "ARE YOU SURE ? ", A$
5090 IF A$ <> "y" AND A$ <> "Y" THEN 5010
5110 GOSUB 6130
5130 RETURN
5150 SCREEN 0: SCREEN 2: REM ** SWITCH TO GRAPHICS WITH FAILSAFE CLEAR **
5170 LINE (0, 0)-(0, MAXY): LINE -(MAXX, MAXY): REM ** DRAW AXES **
5190 X9 = 0: Y9 = 0
5210 REM ** MAKE 10 TIC MARKS ON EACH AXIS **
5230 FOR I = 1 TO 10
5250    PRESET (0, (MAXY - Y9)): PRESET (X9, (MAXY - 0))
5270    X9 = X9 + XSIZE / 10: Y9 = Y9 + YSIZE / 10
5290 NEXT I
5310 PSET (0, MAXY - (MAXY * F(0)) / YSCALE)
5330 FOR I = 0 TO NITER2
5350    X = I * DELTAT: Y = F(I): REM ** DRAW LINE FROM LAST POINT TO THIS POINT **
5370    LINE -(MAXX * X / XSCALE, MAXY - (MAXY * Y) / YSCALE)
5390 NEXT I
5410 A$ = INKEY$: IF A$ = "" THEN 5410: REM ** HOLD GRAPH UNTIL KEY PRESSED **
5430 SCREEN 0: REM ** FLIP BACK TO TEXT SCREEN **
5450 RETURN

5470 REM ** ROUTINE TO READ IN PARAMETERS
5490 REM FIRST LINE SAYS ENGLISH OR METRICS
5510 REM SECOND LINE IS STANDARD DENSITY AND MINIMUM BURNING RATE
5530 REM THIRD LINE NAME OF SPLINE TABLE FILE
5590 REM FOURTH LINE HAS TWO PRESSURE/RB PARAMETERS
5610 REM FIFTH LINE HAS CUTOFF KRATIO FOR ABOVE AND BELOW
5630 REM SIXTH LINE HAS 2 SETS OF PRESSURE/Kn PARAMETERS
5650 OPEN "I", 2, "PROPPARM.SPN"
5670 INPUT #2, A$
5690 PRESCON = 1: VECON = 1: RBCON = 1: IF A$ = "METRIC" THEN 5830
5710 IF A$ = "ENGLISH" THEN 5810
5730 PRINT : PRINT "FIRST RECORD MUST SAY 'ENGLISH' OR 'METRIC IN CAPS"
5750 PRINT : PRINT "FIRST RECORD ACTUALLY SAYS:"
5770 PRINT A$
5790 PRINT "** PROGRAM TERMINATES ABNORMALLY **": STOP
5810 PRESCON = 4.45 / (2.54 * 2.54): VECON = (1 / 3.28084): RBCON = 2.54
5830 INPUT #2, RHOPROP1, MINRB1
5850 INPUT #2, SPLINTB$
5851 REM ** READ SPLINE TABLES, YS, XS, PS, US **
5852 OPEN "I", 3, SPLINTB$
5854 INPUT #3, NS
5860 FOR IS1=1 TO NS:INPUT#3,YS(IS1),XS(IS1),PS(IS1),US(IS1):NEXT IS1
5870 CLOSE #3
5910 LOWPFORVE = XS(1) * 1.01: HIPFORVE = XS(NS) * .999
5930 LOWPFORVE = LOWPFORVE * PRESCON: HIPFORVE = HIPFORVE * PRESCON
5950 INPUT #2, A1, N1, A2, N2
5970 A1 = A1 * RBCON / (PRESCON ^ N1)
5990 A2 = A2 * RBCON / (PRESCON ^ N2)
6010 INPUT #2, CUTOFF
6030 CUTOFF = CUTOFF
6050 INPUT #2, PK1, PN1, PK2, PN2
6070 PK1 = PK1 * PRESCON: PK2 = PK2 * PRESCON
6090 CLOSE #2
6110 RETURN
6130 REM *** ROUTINE FOR PUTTING OUT THRUST CURVE ***
6150 OPEN "O", 1, F$
6170 PRINT #1, BIGR; " "; RFLAT; " "; ICAP; " "; R0BOTTOM; " "; R0TOP; " ";
6190 PRINT #1, H; " "; LENCHRGE; " SIMLAB-F"
6210 PRINT #1, DIGIMP, MPROP, TTOT, NITER2
6230 FOR I = 0 TO NITER2
6250 PRINT #1, F(I), I * DELTAT, VE(I): REM P(I),RB(I)
6270 NEXT I
6290 CLOSE #1
6310 RETURN
6330 REM ** ADJUST BURNING TIME AND RERUN **
6350 PRINT "ENTER BURNING TIME ": INPUT TTOT2
6370 IF TTOT2 >= 0 THEN TTOT1 = TTOT2
6390 IF TTOT1 = 0 THEN TTOT1 = TTOTHLD
6410 REM RHOPROP1/RHOPROP
6430 ADJRATE = ADJRATE * TTOTHLD / TTOT1
6450 NITER = NITER1: DELTAT = TTOT1 / NITER
6470 FRSTRUN = 0
6490 RETURN
6510 REM ** ADJUST EXHAUST VELOCITY DECLARED IMPULSE **
6530 PRINT "ENTER IMPULSE ": INPUT ZDIGIMP1
6550 IF ZDIGIMP1 < 0 THEN ZDIGIMP1 = ZIMPHLD * TTOT1 / TTOTHLD
6570 IF ZDIGIMP1 = 0 THEN ZDIGIMP1 = ZIMPHLD
6590 ADJVE = ZDIGIMP1 / ZIMPHLD
6610 FRSTRUN = 0
6630 RETURN
6650 END

